---
categories: Amazon
title: AWS CLI
...

Amazon propose un outil en ligne de commande pour interagir avec ses outils AWS.

* Documentation : https://docs.aws.amazon.com/cli/latest/index.html

## Installation

Il s'agit d'un ensemble de scripts Python qui sont installable avec PIP mais surtout via un paquet Debian :

~~~
# apt install awscli
~~~

## Configuration

La commande `configure` de stocker dans un fichier les valeurs par défaut pour 4 options courantes.

~~~
$ aws configure
AWS Access Key ID [None]: 
AWS Secret Access Key [None]: 
Default region name [None]: 
Default output format [None]: 
~~~

Si vous renseignez vos identifiants, ils seront stockés dans `~/.aws/credentials`. Vérifiez bien les permissions d'accès à ce fichier car ces identifiants donnent accès à l'ensemble des actions possibles sur AWS.

Il est possible de créer un ou plusieurs profils pour pré-enregistrer des options par compte. Il faudra ensuitre indiquer le nom du profil à utiliser au lancement des commandes.

~~~
$ aws --profile XXX configure
[…]
$ aws --profile XXX [options] <command> <subcommand>
~~~

L'option `--output` permet d'indiquer si on souhaite une sortie en `text`, `xml` ou `json`.

Lors des appels à des commandes, il peut être nécessaire de fournir l'identifiant de l'instance, le nom de la région… Si la commande est exacutée depuis une instance AWS, certaines de ces infos sont dynamiquement accessible depuis des [API de méta-données](Amazon-EC2).
