---
categories: kernel boot
title: Howto Initramfs debug
...

* Documentation : <https://wiki.debian.org/InitramfsDebug>

## UUID

Normalement la partition racine est montée dans `/root` et l'on peut modifier le *fstab* avec `vi /root/etc/fstab` et corriger les UUID ou commenter les lignes problématiques pour les corriger plus tard. 

## Disques LVM

Si les partitions LVM ne sont pas détectées, une solution peut être de forcer leur activation avec `vgchange` :

~~~
(initramfs) lvm
lvm> vgchange -ay
^D
^D
~~~

## Souci LUKS

<https://wiki.debian.org/CryptsetupDebug>
<https://wiki.evolix.org/HowtoLUKS>

On a pu constater lors de mise à jour noyau des soucis lors de la regénération de l'initramfs sur des portables Debian Jessie avec des partitions chiffrées.

~~~
Reading all physical volumes. This may take a while ...
No volume groups found
~~~

Il faut corriger `/etc/crypttab` (mettre à jour l'UUID) et `/etc/fstab`.


## Regénérer l'INITRAMFS

~~~
update-initramfs -k all -u
~~~

## Reconstruire l'INITRAMFS (à relire)

~~~
cd /boot/initramfs
find . | cpio -H newc --create --verbose | gzip -9 > ../initrd.img-${uname -r}
~~~

